#include "E.h"

ActionClass *CreateAclass(char *name)
{
   ActionClass *a;
   
   a=Emalloc(sizeof(ActionClass));
   a->name=duplicate(name);
   a->num=0;
   a->list=NULL;
   return a;
}

Action *CreateAction(char event, char anymod, int mod, int anybut, int but, 
		     char anykey, char *key)
{
   Action *act;
   
   act=Emalloc(sizeof(Action));
   act->action=NULL;
   act->event=event;
   act->anymodifier=anymod;
   act->modifiers=mod;
   act->anybutton=anybut;
   act->button=but;
   act->anykey=anykey;
   if (!key) act->key=0;
   else act->key=XKeysymToKeycode(disp,XStringToKeysym(key));
   return act;
}

void AddToAction(Action *act, int id, void *params)
{
   ActionType *pptr,*ptr,*at;
   
   at=Emalloc(sizeof(ActionType));
   at->Next=NULL;
   at->Type=id;
   at->params=params;
   if (!act->action)
     {
	act->action=at;
     }
   else
     {
	ptr=act->action;
	while(ptr) 
	  {
	     pptr=ptr;
	     ptr=ptr->Next;
	  }
	pptr->Next=at;
     }
}

void AddAction(ActionClass *a, Action *act)
{
   a->num++;
   a->list=Erealloc(a->list,a->num*sizeof(Action *));
   a->list[a->num-1]=act;
}

void EventAclass(XEvent *ev, ActionClass *a)
{
   KeyCode key;
   int i,type,button,modifiers,ok,mouse;
   Action *act;
   
   key=type=button=modifiers=mouse=0;
   switch (ev->type)
     {
      case KeyPress:
	type=EVENT_KEY_DOWN;
	key=ev->xkey.keycode;
	modifiers=ev->xbutton.state&(ShiftMask|LockMask|ControlMask|Mod1Mask|
				     Mod2Mask|Mod3Mask|Mod4Mask|Mod5Mask);
	mouse=0;
	break;
      case KeyRelease:
	type=EVENT_KEY_UP;
	key=ev->xkey.keycode;
	modifiers=ev->xbutton.state&(ShiftMask|LockMask|ControlMask|Mod1Mask|
				     Mod2Mask|Mod3Mask|Mod4Mask|Mod5Mask);
	mouse=0;
	break;
      case ButtonPress:
	type=EVENT_MOUSE_DOWN;
	button=ev->xbutton.button;
	modifiers=ev->xbutton.state&(ShiftMask|LockMask|ControlMask|Mod1Mask|
				     Mod2Mask|Mod3Mask|Mod4Mask|Mod5Mask);
	mouse=1;
	break;
      case ButtonRelease:
	type=EVENT_MOUSE_UP;
	button=ev->xbutton.button;
	modifiers=ev->xbutton.state&(ShiftMask|LockMask|ControlMask|Mod1Mask|
				     Mod2Mask|Mod3Mask|Mod4Mask|Mod5Mask);
	mouse=1;
	break;
      case EnterNotify:
	type=EVENT_MOUSE_ENTER;
	button=-1;
	modifiers=ev->xcrossing.state&(ShiftMask|LockMask|ControlMask|Mod1Mask|
				       Mod2Mask|Mod3Mask|Mod4Mask|Mod5Mask);
	mouse=1;
	break;
      case LeaveNotify:
	type=EVENT_MOUSE_LEAVE;
	button=-1;
	modifiers=ev->xcrossing.state&(ShiftMask|LockMask|ControlMask|Mod1Mask|
				       Mod2Mask|Mod3Mask|Mod4Mask|Mod5Mask);
	mouse=1;
	break;
      default:
	break;
     }
   for(i=0;i<a->num;i++)
     {
	act=a->list[i];
	ok=0;
	if ((act->event==type)&&(act->action))
	  {
	     if (mouse)
	       {
		  if (button<0)
		    {
		       if (act->anymodifier) ok=1;
		       else if (act->modifiers==modifiers) ok=1;
		    }
		  else
		    {
		       if (act->anymodifier)
			 {
			    if (act->anybutton) ok=1;
			    else if (act->button==button) ok=1;
			 }
		       else if (act->modifiers==modifiers)
			 {
			    if (act->anybutton) ok=1;
			    else if (act->button==button) ok=1;
			 }
		    }
	       }
	     else
	       {
		  if (act->anymodifier)
		    {
		       if (act->anykey) ok=1;
		       else if (act->key==key) ok=1;
		    }
		  else if (act->modifiers==modifiers)
		    {
		       if (act->anykey) ok=1;
		       else if (act->key==key) ok=1;
		    }
	       }
	     if (ok) handleAction(act->action);
	  }
	
     }
}

int handleAction (ActionType *Action) {
	
   /* This function will handle any type of action that is passed into
    * it.  ALL internal events should be passed through this function.
    * No exceptions.  --Mandrake (02/26/98)
    */
   
   int error;

   error = (*(ActionFunctions[Action->Type]))(Action->params);
   /* If there is another action in this series, perform it */
   if(!error)
     if(Action->Next)
       error = handleAction(Action->Next);
   return error;
}

int spawnMenu (void *params) {
   return 0;
}

int hideMenu (void *params) {
   return 0;
}

int doNothing (void *params) {
   return 0;
}

int execApplication (void *params) {
   char *sh;
   
   if (!params) return 0;
   if (fork()) return 0;
   setsid();
   sh=usershell(getuid());
   if (execl(sh,sh,"-c",(char *)params,NULL)==-1)
     {
	/* it is a node on the filing sys */
	if (exists((char *)params))
	  {
	     /* it's a file */
	     if (isfile((char *)params))
	       {
		  /* can execute it */
		  if (canexec((char *)params))
		    Alert("There was an error running the program:\n"
			  "%s\n"
			  "This program could not be executed.\n"
			  "I am unsure as to why you could not do this. The file exists,\n"
			  "is a file, and you are allowed to execute it. I suggest you look\n"
			  "into this.\n",
			  (char *)params);
		  /* not executable file */
		  else
		    Alert("There was an error running the program:\n"
			  "%s\n"
			  "This program could not be executed.\n"
			  "This is because the file exists, is a file, but you are unable\n"
			  "to execute it because you do not have execute access to this file.\n",
			  (char *)params);
	       }
	     /* it's not a file */
	     else
	       {
		  /* its a dir */
		  if (isdir((char *)params))
		    Alert("There was an error running the program:\n"
			  "%s\n"
			  "This program could not be executed.\n"
			  "This is because the file is infact a directory.\n",
			  (char *)params);
		  /* its not a file or a dir */
		  else
		    Alert("There was an error running the program:\n"
			  "%s\n"
			  "This program could not be executed.\n"
			  "This is because the file is not a regular file.\n",
			  (char *)params);
	       }
	  }
	/* it doesn't exist */
	else
	  {
	     /* absolute path */	
	     if (((char *)params)[0]=='/')
	       Alert("There was an error running the program:\n"
		     "%s\n"
		     "This program could not be executed.\n"
		     "This is because the file does not exist.\n",
		     (char *)params);
	     /* realtive path */
	     else
	       Alert("There was an error running the program:\n"
		     "%s\n"
		     "This program could not be executed.\n"
		     "This is most probably because this program is not in the\n"
		     "path for your shell which is %s. I suggest you read the manual\n"
		     "page for that shell and read up how to change or add to your\n"
		     "execution path.\n",
		     (char *)params,sh);
	  }
	exit(100);
     }
   exit(0);
}

int alert (void *params) {
   char *pp;
   int i;
   
   pp=duplicate((char *)params);
   i=1;
   if (!pp) return 1;
   if (strlen(pp)<=0) return 1;
   while(pp[i])
     {
	if ((pp[i-1]=='\\')&&(((char *)params)[i]=='n'))
	  {
	     pp[i-1]=' ';pp[i]='\n';
	  }
	i++;
     }
   Alert(pp);
   Efree(pp);
   return 0;
}

int doExit(void *params) {
   EExit(0);
   return 0;
}

int doResize(void *params) {
   EWin *ewin;
   int x,y,w,h;
   
   ewin=mode.ewin=GetEwin();
   if (!ewin) return 0;
   mode.mode=MODE_RESIZE;
   x=mode.x-ewin->x;y=mode.y-ewin->y;
   w=ewin->w>>1;h=ewin->h>>1;
   if ((x<w)&& (y<h) ) mode.resize_detail=0;
   if ((x>=w)&&(y<h) ) mode.resize_detail=1;
   if ((x<w)&& (y>=h)) mode.resize_detail=2;
   if ((x>=w)&&(y>=h)) mode.resize_detail=3;
   mode.start_x=mode.x;mode.start_y=mode.y;
   mode.win_x=ewin->x;mode.win_y=ewin->y;
   mode.win_w=ewin->client.w;mode.win_h=ewin->client.h;
   mode.firstlast=0;
   DrawEwinShape(ewin,mode.resizemode,ewin->x,ewin->y,ewin->client.w,ewin->client.h,mode.firstlast);
   mode.firstlast=1;
   return 0;
}

int doResizeH(void *params) {
   EWin *ewin;
   int x,w;
   
   ewin=mode.ewin=GetEwin();
   if (!ewin) return 0;
   mode.mode=MODE_RESIZE_H;
   x=mode.x-ewin->x;
   w=ewin->w>>1;
   if (x<w) mode.resize_detail=0;
   else     mode.resize_detail=1;
   mode.start_x=mode.x;mode.start_y=mode.y;
   mode.win_x=ewin->x;mode.win_y=ewin->y;
   mode.win_w=ewin->client.w;mode.win_h=ewin->client.h;
   mode.firstlast=0;
   DrawEwinShape(ewin,mode.resizemode,ewin->x,ewin->y,ewin->client.w,ewin->client.h,mode.firstlast);
   mode.firstlast=1;
   return 0;
}

int doResizeV(void *params) {
   EWin *ewin;
   int y,h;
   
   ewin=mode.ewin=GetEwin();
   if (!ewin) return 0;
   mode.mode=MODE_RESIZE_V;
   y=mode.y-ewin->y;
   h=ewin->h>>1;
   if (y<h) mode.resize_detail=0;
   else     mode.resize_detail=1;
   mode.start_x=mode.x;mode.start_y=mode.y;
   mode.win_x=ewin->x;mode.win_y=ewin->y;
   mode.win_w=ewin->client.w;mode.win_h=ewin->client.h;
   mode.firstlast=0;
   DrawEwinShape(ewin,mode.resizemode,ewin->x,ewin->y,ewin->client.w,ewin->client.h,mode.firstlast);
   mode.firstlast=1;
   return 0;
}

int doResizeEnd(void *params) {
   EWin *ewin;
   
   ewin=GetEwin();
   if (!ewin) return 0;
   ICCCM_Configure(ewin);
   mode.mode=MODE_NONE;
   if (mode.noewin)
     mode.ewin=NULL;
   mode.noewin=0;
   mode.firstlast=2;
   DrawEwinShape(ewin,mode.resizemode,ewin->x,ewin->y,ewin->client.w,ewin->client.h,mode.firstlast);
   mode.firstlast=0;
   return 0;
}

int doMove(void *params) {
   EWin *ewin;
   
   ewin=mode.ewin=GetEwin();
   if (!ewin) return 0;
   mode.mode=MODE_MOVE;
   mode.start_x=mode.x;mode.start_y=mode.y;
   mode.win_x=ewin->x;mode.win_y=ewin->y;
   mode.win_w=ewin->client.w;mode.win_h=ewin->client.h;
   mode.firstlast=0;
   DrawEwinShape(ewin,mode.movemode,ewin->x,ewin->y,ewin->client.w,ewin->client.h,mode.firstlast);
   mode.firstlast=1;
   return 0;
}

int doMoveEnd(void *params) {
   EWin *ewin;
   
   ewin=GetEwin();
   if (!ewin) return 0;
   ICCCM_Configure(ewin);
   mode.mode=MODE_NONE;
   if (mode.noewin)
     mode.ewin=NULL;
   mode.noewin=0;
   mode.firstlast=2;
   DrawEwinShape(ewin,mode.movemode,ewin->x,ewin->y,ewin->client.w,ewin->client.h,mode.firstlast);
   mode.firstlast=0;
   return 0;
}

int doRaise(void *params) {
   EWin *ewin;
   
   ewin=GetEwin();
   if (!ewin) return 0;
   RaiseEwin(ewin);
   return 0;
}

int doLower(void *params) {
   EWin *ewin;
   
   ewin=GetEwin();
   if (!ewin) return 0;
   LowerEwin(ewin);
   return 0;
}

int doCleanup(void *params) {
   char *type;
   int method;
   void **lst;
   int i,j,num,speed;
   RectBox *fixed,*ret,*floating;
   char doslide;
   EWin *ewin;
   
   type=(char *)params;
   method=ARRANGE_BY_SIZE;
   speed=mode.slidespeedcleanup;
   doslide=mode.cleanupslide;
   if (params)
     {
	if (!strcmp("order",type)) method=ARRANGE_VERBATIM;
	else if (!strcmp("place",type)) method=ARRANGE_BY_POSITION;
     }
   lst=ListItemType(&num,LIST_TYPE_EWIN);
   if ((lst)&&(num>0))
     {
	fixed=NULL;
	floating=Emalloc(sizeof(RectBox)*num);
	ret=Emalloc(sizeof(RectBox)*(num));
	j=0;
	for(i=0;i<num;i++)
	  {
	     if (((EWin *)lst[i])->desktop&desks.current_mask)
	       {
		  floating[j].data=lst[i];
		  floating[j].x=((EWin *)lst[i])->x;
		  floating[j].y=((EWin *)lst[i])->y;
		  floating[j].w=((EWin *)lst[i])->w;
		  floating[j++].h=((EWin *)lst[i])->h;
	       }
	  }
	ArrangeRects(fixed,0,floating,j,ret,root.w,root.h,method);
	for(i=0;i<j;i++)
	  {
	     if (ret[i].data)
	       {
		  if (doslide)
		    {
		       ewin=(EWin *)ret[i].data;
		       if ((ewin->x!=ret[i].x)||(ewin->y!=ret[i].y))
			 {
			    SlideEwinTo(ewin,ewin->x,ewin->y,ret[i].x,ret[i].y,speed);
			    ICCCM_Configure(ewin);
			 }
		    }
		  else
		    {
		       ewin=(EWin *)ret[i].data;
		       if ((ewin->x!=ret[i].x)||(ewin->y!=ret[i].y))
			 {
			    MoveEwin((EWin *)ret[i].data,ret[i].x,ret[i].y);
			    ICCCM_Configure((EWin *)ret[i].data);
			 }
		    }
	       }
	  }
	Efree(ret);
	Efree(floating);
	Efree(lst);
     }
   return 0;
}

int doKill(void *params) {
   EWin *ewin;
   
   ewin=GetEwin();
   if (!ewin) return 0;
   ICCCM_Delete(ewin);
   return 0;
}

int doKillNasty(void *params) {
   EWin *ewin;
   
   ewin=GetEwin();
   if (!ewin) return 0;
   XDestroyWindow(disp,ewin->client.win);
   return 0;
}

int doNextDesktop(void *params) {
   GotoDesktop(desks.current+1);
   return 0;
}

int doPrevDesktop(void *params) {
   GotoDesktop(desks.current-1);
   return 0;
}

int initFunctionArray (void) {
   ActionFunctions[ACTION_NONE] = (int(*)(void *))(doNothing);
   ActionFunctions[ACTION_EXIT] = (int(*)(void *))(doExit);
   ActionFunctions[ACTION_EXEC] = (int(*)(void *))(execApplication);
   ActionFunctions[ACTION_ALERT] = (int(*)(void *))(Alert);
   ActionFunctions[ACTION_SHOW_MENU] = (int (*)(void *))(spawnMenu);
   ActionFunctions[ACTION_HIDE_MENU] = (int (*)(void *))(hideMenu);
   ActionFunctions[ACTION_MOVE] = (int (*)(void *))(doMove);
   ActionFunctions[ACTION_RESIZE] = (int (*)(void *))(doResize);
   ActionFunctions[ACTION_RAISE] = (int (*)(void *))(doRaise);
   ActionFunctions[ACTION_LOWER] = (int (*)(void *))(doLower);
   ActionFunctions[ACTION_CLEANUP] = (int (*)(void *))(doCleanup);
   ActionFunctions[ACTION_RESIZE_H] = (int (*)(void *))(doResizeH);
   ActionFunctions[ACTION_RESIZE_V] = (int (*)(void *))(doResizeV);
   ActionFunctions[ACTION_KILL] = (int (*)(void *))(doKill);
   ActionFunctions[ACTION_KILL_NASTY] = (int (*)(void *))(doKillNasty);
   ActionFunctions[ACTION_DESKTOP_NEXT] = (int (*)(void *))(doNextDesktop);
   ActionFunctions[ACTION_DESKTOP_PREV] = (int (*)(void *))(doPrevDesktop);
   return 0;
}
