#include "E.h"

EWin *GetEwin()
{
   return mode.ewin;
}

void SlideEwinTo(EWin *ewin, int fx, int fy, int tx, int ty, int speed)
{
   int k,spd,x,y,min;
   struct timeval timev1,timev2;
   int dsec,dusec;
   double tm;
   char firstlast;
   Window winid;
   
   winid=ewin->client.win;
   spd=16;min=2;firstlast=0;
   mode.doingslide=1;
   for(k=0;k<1024;k+=spd)
     {
	gettimeofday(&timev1,NULL);
	x=((fx*(1023-k))+(tx*k))>>10;
	y=((fy*(1023-k))+(ty*k))>>10;
	DrawEwinShape(ewin,mode.slidemode,x,y,ewin->client.w,ewin->client.h,firstlast);
	if (firstlast==0) firstlast=1;
	CheckEvent();
	if (!FindItem(NULL,winid,LIST_FINDBY_ID,LIST_TYPE_EWIN)) 
	  {
	     mode.doingslide=0;
	     return;
	  }
	XSync(disp,False);
	gettimeofday(&timev2,NULL);
	dsec=timev2.tv_sec-timev1.tv_sec;
	dusec=timev2.tv_usec-timev1.tv_usec;
	if (dusec<0)
	  {
	     dsec--;dusec+=1000000;
	  }
	tm=(double)dsec+(((double)dusec)/1000000);
	spd=(int)((double)speed*tm);
	if (spd<min) spd=min;
     }
   DrawEwinShape(ewin,mode.slidemode,x,y,ewin->client.w,ewin->client.h,2);
   MoveEwin(ewin,tx,ty);
   mode.doingslide=0;
}

void AddToFamily(Window win)
{
   EWin *ewin;
   void **lst;
   int i,j,k,num,speed,fx,fy,x,y;
   char doslide;
   RectBox *fixed,*ret,newrect;
   Window winid;
   
   ewin=FindItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin) return;
   winid=win;
   speed=mode.slidespeedmap;
   doslide=mode.mapslide;
   ewin=Adopt(win);
   if (ewin->client.start_iconified)
     {
	ewin->iconified=1;
     }
   x=0;y=0;
   ResizeEwin(ewin,ewin->client.w,ewin->client.h);
   if (!ewin->client.already_placed)
     {
	ewin->client.already_placed=1;
	lst=ListItemType(&num,LIST_TYPE_EWIN);
	if ((lst)&&(num>0))
	  {
	     fixed=Emalloc(sizeof(RectBox)*num);
	     ret=Emalloc(sizeof(RectBox)*(num+1));
	     j=0;
	     for(i=0;i<num;i++)
	       {
		  if ((lst[i]!=ewin)&&
		      (((EWin *)lst[i])->desktop&desks.current_mask))
		    {
		       fixed[j].data=lst[i];
		       fixed[j].x=((EWin *)lst[i])->x;
		       fixed[j].y=((EWin *)lst[i])->y;
		       fixed[j].w=((EWin *)lst[i])->w;
		       fixed[j++].h=((EWin *)lst[i])->h;
		    }
	       }
	     newrect.data=ewin;
	     newrect.x=0;newrect.y=0;
	     newrect.w=ewin->w;
	     newrect.h=ewin->h;
	     ArrangeRects(fixed,j,&newrect,1,ret,root.w,root.h,ARRANGE_BY_SIZE);
	     for(i=0;i<j+1;i++)
	       {
		  if (ret[i].data==ewin) 
		    {
		       x=ret[i].x;y=ret[i].y;i=j+1;
		    }
	       }
	     Efree(ret);
	     Efree(fixed);
	     Efree(lst);
	  }
	else
	  {
	     x=(root.w-ewin->w)>>1;
	     y=(root.h-ewin->h)>>1;
	  }
     }
   else
     {
	x=ewin->client.x-ewin->border->border.left;
	y=ewin->client.y-ewin->border->border.top;
     }
   AddItem(ewin,"EWIN",ewin->client.win,LIST_TYPE_EWIN);
   if ((doslide)&&(!mode.doingslide))
     {
	MoveEwin(ewin,root.w,root.h);
	MoveEwinToDesktop(ewin,desks.current);
	k=rand()%4;
	if (k==0)
	  {
	     fx=(rand()%(root.w))-ewin->w;
	     fy=-ewin->h;
	  }
	else if (k==1)
	  {
	     fx=(rand()%(root.w));
	     fy=root.h;
	  }
	else if (k==2)
	  {
	     fx=-ewin->w;
	     fy=(rand()%(root.h));
	  }
	else
	  {
	     fx=root.w;
	     fy=(rand()%(root.h))-ewin->h;
	  }
	SlideEwinTo(ewin,fx,fy,x,y,speed);
     }
   else
     {
	MoveEwinToDesktop(ewin,desks.current);
	MoveEwin(ewin,x,y);
     }
   if (!FindItem(NULL,winid,LIST_FINDBY_ID,LIST_TYPE_EWIN)) return;
   ICCCM_Configure(ewin);
}
   
void HonorIclass(char *s, int id)
{
   AwaitIclass *a;
   EWin *ewin;
   
   a=RemoveItem(s,0,LIST_FINDBY_NAME,LIST_TYPE_AWAIT_ICLASS);
   if (!a) return;
   ewin=FindItem(NULL,a->client_win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin)
     {
	if (a->ewin_bit<ewin->border->num_winparts)
	  {
	     if ((ewin->border->part[a->ewin_bit].iclass->external)&&
		 (!ewin->bits[a->ewin_bit].win)&&(id))
	       {
		  ewin->bits[a->ewin_bit].win=id;
		  RealiseEwinWinpart(ewin,a->ewin_bit);
		  XMapWindow(disp,id);
		  PropagateShapes(ewin->win);
	       }
	  }
     }
   Efree(a);
}

void SyncBorderToEwin(EWin *ewin)
{
   Border *b;
   char title[10240];
   int i;
   
   b=ewin->border;
   strncpy(title,ewin->client.title,10240);
   ICCCM_GetTitle(ewin);
   ICCCM_GetInfo(ewin);
   ICCCM_GetHints(ewin);
   ICCCM_GetShapeInfo(ewin);
   ICCCM_GetGeoms(ewin);
   SetEwinBorder(ewin);
   if (b!=ewin->border)
     {
	ICCCM_MatchSize(ewin);
	MoveResizeEwin(ewin,ewin->client.x,ewin->client.y,ewin->client.w,
		       ewin->client.h);
     }
   else if (strcmp(title,ewin->client.title))
     {
	for (i=0;i<ewin->border->num_winparts;i++)
	  {
	     if (ewin->border->part[i].flags==FLAG_TITLE)
	       ChangeEwinWinpartContents(ewin,i);
	  }
     }
}

void RealiseEwinWinpart(EWin *ewin, int i)
{
   int move=0,resize=0;
   
   if ((ewin->bits[i].x!=ewin->bits[i].cx)||(ewin->bits[i].y!=ewin->bits[i].cy))
     move=1;
   if ((ewin->bits[i].w!=ewin->bits[i].cw)||(ewin->bits[i].h!=ewin->bits[i].ch))
     resize=1;
   if ((move)&&(resize)) 
     XMoveResizeWindow(disp,ewin->bits[i].win,ewin->bits[i].x,ewin->bits[i].y,
		       ewin->bits[i].w,ewin->bits[i].h);
   else if (move)
     XMoveWindow(disp,ewin->bits[i].win,ewin->bits[i].x,ewin->bits[i].y);
   else if (resize)
     XResizeWindow(disp,ewin->bits[i].win,ewin->bits[i].w,ewin->bits[i].h);
}

int DrawEwinWinpart(EWin *ewin, int i)
{
   int move=0,resize=0,active=0,state=0,ret=0;
   
   active=ewin->state;
   if ((ewin->bits[i].x!=ewin->bits[i].cx)||(ewin->bits[i].y!=ewin->bits[i].cy))
     move=1;
   if ((ewin->bits[i].w!=ewin->bits[i].cw)||(ewin->bits[i].h!=ewin->bits[i].ch))
     resize=1;
   if ((resize)||(ewin->bits[i].expose))
     {
	state=ewin->bits[i].state;
	IclassApply(ewin->border->part[i].iclass,ewin->bits[i].win,
		    ewin->bits[i].w,ewin->bits[i].h,ewin->state,state,
		    ewin->bits[i].expose);
        if (ewin->border->part[i].flags==FLAG_TITLE)
	  TclassApply(ewin->border->part[i].iclass,ewin->bits[i].win,
		      ewin->bits[i].w,ewin->bits[i].h,active,ewin->state,
		      ewin->bits[i].expose,ewin->border->part[i].tclass,
		      ewin->client.title);
	ret=1;
     }
   if ((move)||(resize)) ret=1;
   ewin->bits[i].cx=ewin->bits[i].x;
   ewin->bits[i].cy=ewin->bits[i].y;
   ewin->bits[i].cw=ewin->bits[i].w;
   ewin->bits[i].ch=ewin->bits[i].h;
   ewin->bits[i].expose=0;
   return ret;
}

int ChangeEwinWinpart(EWin *ewin, int i)
{
   int active=0,state=0,ret=0;
   
   active=ewin->state;
   state=ewin->bits[i].state;
   IclassApply(ewin->border->part[i].iclass,ewin->bits[i].win,
	       ewin->bits[i].w,ewin->bits[i].h,ewin->state,state,
	       ewin->bits[i].expose);
   if (ewin->border->part[i].flags==FLAG_TITLE)
     TclassApply(ewin->border->part[i].iclass,ewin->bits[i].win,
		 ewin->bits[i].w,ewin->bits[i].h,active,state,
		 ewin->bits[i].expose,ewin->border->part[i].tclass,
		 ewin->client.title);
   if (ewin->bits[i].win) ChangeEwinWinpartContents(ewin,i);
   PropagateShapes(ewin->win);
   ret=1;
   return ret;
}

void DrawEwin(EWin *ewin)
{
   int i,active,state;

   active=ewin->state;
   for (i=0;i<ewin->border->num_winparts;i++)
     {
	state=ewin->bits[i].state;
	IclassApply(ewin->border->part[i].iclass,ewin->bits[i].win,
		    ewin->bits[i].w,ewin->bits[i].h,ewin->state,state,
		    ewin->bits[i].expose);
	if (ewin->border->part[i].flags==FLAG_TITLE)
	  TclassApply(ewin->border->part[i].iclass,ewin->bits[i].win,
		      ewin->bits[i].w,ewin->bits[i].h,active,state,
		      ewin->bits[i].expose,ewin->border->part[i].tclass,
		      ewin->client.title);
     }
   PropagateShapes(ewin->win);
}

int ChangeEwinWinpartContents(EWin *ewin, int i)
{
   int active=0,state=0,ret=0;

   ret=1;
   switch (ewin->border->part[i].flags)
     {
      case FLAG_TITLE:
	TclassApply(ewin->border->part[i].iclass,ewin->bits[i].win,
		    ewin->bits[i].w,ewin->bits[i].h,active,state,
		    ewin->bits[i].expose,ewin->border->part[i].tclass,
		    ewin->client.title);
	break;
      case FLAG_MINIICON:
	break;
      default:
	break;
     }
   return ret;
}

void CalcEwinWinpart(EWin *ewin, int i)
{
   int x,y,w,h,ox,oy,max,min;
   int topleft,bottomright;
   
   topleft=ewin->border->part[i].geom.topleft.originbox;
   bottomright=ewin->border->part[i].geom.bottomright.originbox;
   if (topleft>=0) CalcEwinWinpart(ewin,topleft);
   if (bottomright>=0) CalcEwinWinpart(ewin,bottomright);
   x=y=0;
   if (topleft==-1)
     {
	x=((ewin->border->part[i].geom.topleft.x.percent*ewin->w)>>10)+
	  ewin->border->part[i].geom.topleft.x.absolute;
	y=((ewin->border->part[i].geom.topleft.y.percent*ewin->h)>>10)+
	  ewin->border->part[i].geom.topleft.y.absolute;
     }
   else if (topleft>=0)
     {
	x=((ewin->border->part[i].geom.topleft.x.percent*
	     ewin->bits[topleft].w)>>10)+
	  ewin->border->part[i].geom.topleft.x.absolute+
	  ewin->bits[topleft].x;
	y=((ewin->border->part[i].geom.topleft.y.percent*
	     ewin->bits[topleft].h)>>10)+
	  ewin->border->part[i].geom.topleft.y.absolute+
	  ewin->bits[topleft].y;
     }
   ox=oy=0;
   if (bottomright==-1)
     {
	ox=((ewin->border->part[i].geom.bottomright.x.percent*ewin->w)>>10)+
	  ewin->border->part[i].geom.bottomright.x.absolute;
	oy=((ewin->border->part[i].geom.bottomright.y.percent*ewin->h)>>10)+
	  ewin->border->part[i].geom.bottomright.y.absolute;
     }
   else if (bottomright>=0)
     {
	ox=((ewin->border->part[i].geom.bottomright.x.percent*
	     ewin->bits[bottomright].w)>>10)+
	  ewin->border->part[i].geom.bottomright.x.absolute+
	  ewin->bits[bottomright].x;
	oy=((ewin->border->part[i].geom.bottomright.y.percent*
	     ewin->bits[bottomright].h)>>10)+
	  ewin->border->part[i].geom.bottomright.y.absolute+
	  ewin->bits[bottomright].y;
     }
   w=(ox-x)+1;
   max=ewin->border->part[i].geom.width.max;
   min=ewin->border->part[i].geom.width.min;
   if (w>max)
     {
	w=max;x=((x+ox)-w)>>1;
     }
   h=(oy-y)+1;
   max=ewin->border->part[i].geom.height.max;
   min=ewin->border->part[i].geom.height.min;
   if (h>max)
     {
	h=max;y=((y+oy)-h)>>1;
     }
   ewin->bits[i].x=x;ewin->bits[i].y=y;
   ewin->bits[i].w=w;ewin->bits[i].h=h;
}

void CalcEwinSizes(EWin *ewin)
{
   int i;
   char reshape;
   
   if (!ewin) return;
   for (i=0;i<ewin->border->num_winparts;i++)
     CalcEwinWinpart(ewin,i);
   for (i=0;i<ewin->border->num_winparts;i++)
     RealiseEwinWinpart(ewin,i);
   XSync(disp,False);
   reshape=0;
   for (i=0;i<ewin->border->num_winparts;i++)
     reshape|=DrawEwinWinpart(ewin,i);
   if (reshape)
     PropagateShapes(ewin->win);	
   XSync(disp,False);
}

EWin *Adopt(Window win)
{
   EWin *ewin;
   
   ewin=CreateEwin();
   ewin->client.win=win;
   ICCCM_GetTitle(ewin);
   ICCCM_GetInfo(ewin);
   ICCCM_GetHints(ewin);
   ICCCM_GetColormap(ewin);
   ICCCM_GetShapeInfo(ewin);
   ICCCM_GetGeoms(ewin);
   SetEwinBorder(ewin);
   ICCCM_MatchSize(ewin);
   ICCCM_Adopt(ewin,win);
   return ewin;
}

EWin *CreateEwin()
{
   EWin *ewin;
   
   ewin=Emalloc(sizeof(EWin));
   ewin->win=0;
   ewin->x=-1;
   ewin->y=-1;
   ewin->w=-1;
   ewin->h=-1;
   ewin->client.win=0;
   ewin->client.x=-1;
   ewin->client.y=-1;
   ewin->client.w=-1;
   ewin->client.h=-1;
   ewin->client.title=NULL;
   ewin->client.class=NULL;
   ewin->client.name=NULL;
   ewin->client.command=NULL;
   ewin->client.machine=NULL;
   ewin->client.icon_name=NULL;
   ewin->client.is_group_leader=0;
   ewin->client.no_resize_h=0;
   ewin->client.no_resize_v=0;
   ewin->client.shaped=0;
   ewin->client.icon_win=0;
   ewin->client.icon_pmap=0;
   ewin->client.icon_mask=0;
   ewin->client.start_iconified=0;
   ewin->client.group=0;
   ewin->client.need_input=0;
   ewin->client.transient=0;
   ewin->client.already_placed=0;
   ewin->client.aspect_min=0.0;
   ewin->client.aspect_max=65535.0;
   ewin->client.w_inc=1;
   ewin->client.h_inc=1;
   ewin->client.base_w=0;
   ewin->client.base_h=0;
   ewin->client.width.min=0;
   ewin->client.height.min=0;
   ewin->client.width.max=65535;
   ewin->client.height.max=65535;
   ewin->border=NULL;
   ewin->bits=NULL;
   ewin->state=0;
   ewin->sticky=0;
   ewin->desktop=0;
   ewin->group=0;
   ewin->border=NULL;
   ewin->visible=0;
   ewin->active=0;
   ewin->iconified=0;
   
   ewin->win=ECreateWindow(root.win,-10,-10,1,1,1);
   XSelectInput(disp,ewin->win,FocusChangeMask|SubstructureNotifyMask|
		SubstructureRedirectMask|EnterWindowMask|LeaveWindowMask|
		PointerMotionMask|PropertyChangeMask|FocusChangeMask);
   return ewin;
}

void FreeEwin(EWin *ewin)
{
   if (ewin->client.title) Efree(ewin->client.title);
   if (ewin->client.class) Efree(ewin->client.class);
   if (ewin->client.name) Efree(ewin->client.name);
   if (ewin->client.command) Efree(ewin->client.command);
   if (ewin->client.machine) Efree(ewin->client.machine);
   if (ewin->client.icon_name) Efree(ewin->client.icon_name);
   if (ewin->win) XDestroyWindow(disp,ewin->win);
   if ((ewin->border)&&(ewin->bits))
     Efree(ewin->bits);
   Efree(ewin);
}

void SetEwinBorder(EWin *ewin)
{
   int i;
   Border *b;
   char s[1024];
   AwaitIclass *await;
   
   b=(Border *)FindItem("DEFAULT",0,LIST_FINDBY_NAME,LIST_TYPE_BORDER);
   if (ewin->border==b) return;
   if (ewin->border)
     {
	for (i=0;i<b->num_winparts;i++)
	  {
	     if (ewin->bits[i].win) XDestroyWindow(disp,ewin->bits[i].win);
	  }
	Efree(ewin->bits);
     }
   if (!b) return;
   ewin->border=b;
   ewin->bits=Emalloc(sizeof(EWinBit)*b->num_winparts);
   for (i=0;i<b->num_winparts;i++)
     {
	if (b->part[i].iclass->external)
	  {
	     ewin->bits[i].win=0;
	     sprintf(s,"request imageclass %s",b->part[i].iclass->name);
	     CommsBroadcast(s);
	     await=Emalloc(sizeof(AwaitIclass));
	     await->client_win=ewin->client.win;
	     await->ewin_bit=i;
	     await->iclass=b->part[i].iclass;
	     AddItem(await,b->part[i].iclass->name,0,LIST_TYPE_AWAIT_ICLASS);
	  }
	else
	  {
	     ewin->bits[i].win=ECreateWindow(ewin->win,-10,-10,1,1,0);
	     XMapWindow(disp,ewin->bits[i].win);
	     /*
	      * KeyPressMask KeyReleaseMask ButtonPressMask ButtonReleaseMask
	      * EnterWindowMask LeaveWindowMask PointerMotionMask 
	      * PointerMotionHintMask Button1MotionMask Button2MotionMask
	      * Button3MotionMask Button4MotionMask Button5MotionMask
	      * ButtonMotionMask KeymapStateMask ExposureMask 
	      * VisibilityChangeMask StructureNotifyMask ResizeRedirectMask 
	      * SubstructureNotifyMask SubstructureRedirectMask 
	      * FocusChangeMask PropertyChangeMas ColormapChangeMask 
	      * OwnerGrabButtonMask
	      */
	     XSelectInput(disp,ewin->bits[i].win,
			  ExposureMask|KeyPressMask|KeyReleaseMask|
			  ButtonPressMask|ButtonReleaseMask|
			  EnterWindowMask|LeaveWindowMask|PointerMotionMask);
	     ewin->bits[i].x=-1;
	     ewin->bits[i].y=-1;
	     ewin->bits[i].w=-1;
	     ewin->bits[i].h=-1;
	     ewin->bits[i].cx=-2;
	     ewin->bits[i].cy=-2;
	     ewin->bits[i].cw=-2;
	     ewin->bits[i].ch=-2;
	     ewin->bits[i].state=0;
	     ewin->bits[i].expose=0;
	  }
     }
}

void ResizeEwin(EWin *ewin, int w, int h)
{
   ewin->client.w=w;
   ewin->client.h=h;
   ICCCM_MatchSize(ewin);
   ewin->w=ewin->client.w+ewin->border->border.left+ewin->border->border.right;
   ewin->h=ewin->client.h+ewin->border->border.top+ewin->border->border.bottom;
   ICCCM_Configure(ewin);
   XResizeWindow(disp,ewin->win,ewin->w,ewin->h);
   CalcEwinSizes(ewin);
}

void MoveEwin(EWin *ewin, int x, int y)
{
   ewin->x=x;
   ewin->y=y;
   XMoveWindow(disp,ewin->win,ewin->x,ewin->y);
}

void MoveResizeEwin(EWin *ewin, int x, int y, int w, int h)
{
   ewin->x=x;
   ewin->y=y;
   ewin->client.w=w;
   ewin->client.h=h;
   ICCCM_MatchSize(ewin);
   ewin->w=ewin->client.w+ewin->border->border.left+ewin->border->border.right;
   ewin->h=ewin->client.h+ewin->border->border.top+ewin->border->border.bottom;
   ICCCM_Configure(ewin);
   XMoveResizeWindow(disp,ewin->win,ewin->x,ewin->y,ewin->w,ewin->h);
   XMoveWindow(disp,ewin->win,ewin->x,ewin->y);
   XResizeWindow(disp,ewin->win,ewin->w,ewin->h);
   CalcEwinSizes(ewin);
}

void RaiseEwin(EWin *ewin)
{
   if (ewin->win) XRaiseWindow(disp,ewin->win);
}

void LowerEwin(EWin *ewin)
{
   if (ewin->win) XLowerWindow(disp,ewin->win);
}

void ShowEwin(EWin *ewin)
{
   if (ewin->visible) return;
   if (ewin->client.win) 
     {
	XMapWindow(disp,ewin->client.win);
     }
   if (ewin->win) 
     {
	XRaiseWindow(disp,ewin->win);
	XMapWindow(disp,ewin->win);
     }
   ewin->visible=1;
}

void HideEwin(EWin *ewin)
{
   if (!ewin->visible) return;
   if (ewin->win) 
     {
	XUnmapWindow(disp,ewin->win);
     }
   ewin->visible=0;
}

Border *CreateBorder(char *name)
{
   Border *b;
   
   b=Emalloc(sizeof(Border));
   b->name=strdup(name);
   b->border.left=0;
   b->border.right=0;
   b->border.top=0;
   b->border.bottom=0;
   b->num_winparts=0;
   b->part=NULL;
   return b;
}

void AddBorderPart(Border *b, ImageClass *iclass, ActionClass *aclass,
		   TextClass *tclass, char ontop, int flags, char isregion, 
		   int wmin, int wmax, int hmin, int hmax, int torigin, 
		   int txp, int txa, int typ, int tya, int borigin, int bxp, 
		   int bxa, int byp, int bya)
{
   int n;
   
   b->num_winparts++;
   n=b->num_winparts;
   b->part=Erealloc(b->part,n*sizeof(WinPart));
   b->part[n-1].iclass=iclass;
   b->part[n-1].aclass=aclass;
   b->part[n-1].tclass=tclass;
   b->part[n-1].ontop=ontop;
   b->part[n-1].flags=flags;
   b->part[n-1].region.is=isregion;
   b->part[n-1].geom.width.min=wmin;
   b->part[n-1].geom.width.max=wmax;
   b->part[n-1].geom.height.min=hmin;
   b->part[n-1].geom.height.max=hmax;
   b->part[n-1].geom.topleft.originbox=torigin;
   b->part[n-1].geom.topleft.x.percent=txp;
   b->part[n-1].geom.topleft.x.absolute=txa;
   b->part[n-1].geom.topleft.y.percent=typ;
   b->part[n-1].geom.topleft.y.absolute=tya;
   b->part[n-1].geom.bottomright.originbox=borigin;
   b->part[n-1].geom.bottomright.x.percent=bxp;
   b->part[n-1].geom.bottomright.x.absolute=bxa;
   b->part[n-1].geom.bottomright.y.percent=byp;
   b->part[n-1].geom.bottomright.y.absolute=bya;
}

