#include "E.h"
#include "config.h"
#include "actions.h"

int testForComment(char *line) {

	if(line[0] == '#' || line[0] == '\n' || line[0] == 0)
		return 1;
	else 
		return 0;

}

int GetNextLine (char *line,FILE *ConfigFile) {

	if(!fgets(line,sizeof(line),ConfigFile))
		return 0;
	line[strlen(line) -1] = 0;
	if(testForComment(line)) {
		GetNextLine(line,ConfigFile);
		return 1;
	} else {
		return 1;
	}

}

StringType *GenerateStringList (char *file) {

	FILE *definitionFile;
	char line[FILENAME_MAX];
	short definition;
	char s[255];
	StringType *returnList;
	long StringCount;


	if(!file) 
		definitionFile = fopen("definitions","r");
	else 
		definitionFile = fopen(file,"r");
	if(!definitionFile) {
		Alert("Enlightenment cannot load your string definitions file.\n"
				"Enlightenment can probably continue to attempt to load\n"
				"however this error may prove to be fatal.\n"
				"If you do not require a definitions file, you should\n"
				"create a blank file to avoid this error message in\n"
				"the future.\n");
	}
	while(GetNextLine(line,definitionFile)) {
		sscanf(line,"%d %s",&definition,s);
		if(!returnList)
			returnList = Emalloc(sizeof(StringType));
		else
			returnList = Erealloc(StringList,sizeof(StringType) * (StringCount + 1));
		returnList[StringCount].definition = definition;
		returnList[StringCount].string = Emalloc(sizeof(char) * (strlen(s) +1));
		strcpy(returnList[StringCount].string,s);
		++StringCount;
	}
	--StringCount;
	fclose(definitionFile);

	return returnList;

}

int ReturnStringReference (StringType *StringSet, char *actionString) {

	long i=0;
	long StringCount = sizeof(StringSet) / sizeof(StringType);
	for(i=0;i<=StringCount;StringCount++)
		if(!strcasecmp(StringSet[i].string,actionString))
			return StringSet[i].definition;
	return 0;

}

int LoadConfigFile(char *file) {

	FILE *ConfigFile;
	char s[FILENAME_MAX];
	char s1[FILENAME_MAX];
	char s2[FILENAME_MAX];
	char block[FILENAME_MAX];

	ConfigFile = fopen(file,"r");
	if(!ConfigFile)
		return 0;
	while(GetNextLine(s,ConfigFile)) {
		sscanf(s,"%s %s",s1,s2);
		switch(ReturnStringReference(StringList,s1)) {
			case CONFIG_TEXT:
			case CONFIG_MENU:
			case CONFIG_BORDER:
			case CONFIG_BUTTON:
			case CONFIG_DESKTOP:
			case CONFIG_ICONBOX:
			case CONFIG_EXEC:
			default:
				break;
		}
	}
	fclose(ConfigFile);
	return 1;

}
