#include "E.h"

void GotoDesktop(int num)
{
   EWin *ewin;
   void **lst;
   int i,n;
   
   desks.current=num&0x1f;
   desks.current_mask=1<<(desks.current);
   lst=ListItemType(&n,LIST_TYPE_EWIN);
   if ((lst)&&(n>0))
     {
	for(i=0;i<n;i++) 
	  {
	     ewin=(EWin *)lst[i];
	     ConformEwinToDesktop(ewin);
	  }
	Efree(lst);
     }
   RefreshCurrentDesktop();
}

void RefreshCurrentDesktop()
{
   Desk *dsk;
   int r,g,b,w,h,x,y,ww,hh;
   Pixmap pmap,mask;
   GC gc;
   XGCValues gcv;
   char hasbg,hasfg;
   
   dsk=&desks.desk[desks.current];
   r=dsk->bg.solid.r;
   g=dsk->bg.solid.g;
   b=dsk->bg.solid.b;
   dsk->bg.solid.pixel=Imlib_best_color_match(id,&r,&g,&b);
   pmap=0;gc=0;w=0;h=0;
   hasbg=0;hasfg=0;
   if (!dsk->pmap)
     {
	if (dsk->bg.file)
	  {
	     if (!dsk->bg.im)
	       dsk->bg.im=ELoadImage(dsk->bg.file);
	  }
	if (dsk->top.file)
	  {
	     if (!dsk->top.im)
	       dsk->top.im=ELoadImage(dsk->top.file);
	  }
     }
   if (dsk->top.im) hasfg=1;
   if (dsk->bg.im) hasbg=1;
   if ((hasfg)&&(hasbg))
     {
	if (dsk->bg.xperc>0) w=(root.w*dsk->bg.xperc)>>10;
	else w=dsk->bg.im->rgb_width;
	if (dsk->bg.yperc>0) h=(root.h*dsk->bg.yperc)>>10;
	else h=dsk->bg.im->rgb_height;
	if (dsk->bg.keep_aspect)
	  {
	     if (((w<<10)/h)!=
		 ((dsk->bg.im->rgb_width<<10)/dsk->bg.im->rgb_height))
	       h=((w*dsk->bg.im->rgb_height)/dsk->bg.im->rgb_width);
	  }
	dsk->pmap=XCreatePixmap(disp,root.win,root.w,root.h,root.depth);
	gc=XCreateGC(disp,dsk->pmap,0,&gcv);
	if (!dsk->bg.tile)
	  {
	     XSetForeground(disp,gc,dsk->bg.solid.pixel);
	     XFillRectangle(disp,dsk->pmap,gc,0,0,root.w,root.h);
	  }
	x=((root.w-w)*dsk->bg.xjust)>>10;
	y=((root.h-h)*dsk->bg.yjust)>>10;
	Imlib_render(id,dsk->bg.im,w,h);
	pmap=Imlib_move_image(id,dsk->bg.im);
	XSetTile(disp,gc,pmap);
	XSetTSOrigin(disp,gc,x,y);
	XSetFillStyle(disp,gc,FillTiled);
	if (!dsk->bg.tile) XFillRectangle(disp,dsk->pmap,gc,x,y,w,h);
	else XFillRectangle(disp,dsk->pmap,gc,0,0,root.w,root.h);
	Imlib_free_pixmap(id,pmap);

	if (dsk->top.xperc>0) ww=(root.w*dsk->top.xperc)>>10;
	else ww=dsk->top.im->rgb_width;
	if (dsk->top.yperc>0) hh=(root.h*dsk->top.yperc)>>10;
	else hh=dsk->top.im->rgb_height;
	if (dsk->top.keep_aspect)
	  {
	     if (((ww<<10)/hh)!=
		 ((dsk->top.im->rgb_width<<10)/dsk->top.im->rgb_height))
	       hh=((ww*dsk->top.im->rgb_height)/dsk->top.im->rgb_width);
	  }
	Imlib_render(id,dsk->top.im,ww,hh);
	pmap=Imlib_move_image(id,dsk->top.im);
        mask=Imlib_move_mask(id,dsk->top.im);
	x=((root.w-ww)*dsk->top.xjust)>>10;
	y=((root.h-hh)*dsk->top.yjust)>>10;
	XSetTile(disp,gc,pmap);
	XSetTSOrigin(disp,gc,x,y);
	XSetFillStyle(disp,gc,FillTiled);
	if (mask)
	  {
	     XSetClipMask(disp,gc,mask);
	     XSetClipOrigin(disp,gc,x,y);
	  }
	XFillRectangle(disp,dsk->pmap,gc,x,y,ww,hh);
	Imlib_free_pixmap(id,pmap);
     }
   else if (hasbg)
     {
	if (dsk->bg.xperc>0) w=(root.w*dsk->bg.xperc)>>10;
	else w=dsk->bg.im->rgb_width;
	if (dsk->bg.yperc>0) h=(root.h*dsk->bg.yperc)>>10;
	else h=dsk->bg.im->rgb_height;
	if (dsk->bg.keep_aspect)
	  {
	     if (((w<<10)/h)!=
		 ((dsk->bg.im->rgb_width<<10)/dsk->bg.im->rgb_height))
	       h=((w*dsk->bg.im->rgb_height)/dsk->bg.im->rgb_width);
	  }
	if (dsk->bg.tile)
	  {
	     dsk->pmap=XCreatePixmap(disp,root.win,w,h,root.depth);
	     gc=XCreateGC(disp,dsk->pmap,0,&gcv);
	  }
	else
	  {	  
	     dsk->pmap=XCreatePixmap(disp,root.win,root.w,root.h,root.depth);
	     gc=XCreateGC(disp,dsk->pmap,0,&gcv);
	     XSetForeground(disp,gc,dsk->bg.solid.pixel);
	     XFillRectangle(disp,dsk->pmap,gc,0,0,root.w,root.h);
	  }
	x=((root.w-w)*dsk->bg.xjust)>>10;
	y=((root.h-h)*dsk->bg.yjust)>>10;
	Imlib_render(id,dsk->bg.im,w,h);
	pmap=Imlib_move_image(id,dsk->bg.im);
	XSetTile(disp,gc,pmap);
	XSetTSOrigin(disp,gc,x,y);
	XSetFillStyle(disp,gc,FillTiled);
	if (dsk->bg.tile)
	  XFillRectangle(disp,dsk->pmap,gc,0,0,w,h);
	else
	  XFillRectangle(disp,dsk->pmap,gc,x,y,w,h);
	Imlib_free_pixmap(id,pmap);
     }
   else if (hasfg)
     {
	dsk->pmap=XCreatePixmap(disp,root.win,root.w,root.h,root.depth);
	gc=XCreateGC(disp,dsk->pmap,0,&gcv);
	XSetForeground(disp,gc,dsk->bg.solid.pixel);
	XFillRectangle(disp,dsk->pmap,gc,0,0,root.w,root.h);
	if (dsk->top.xperc>0) ww=(root.w*dsk->top.xperc)>>10;
	else ww=dsk->top.im->rgb_width;
	if (dsk->top.yperc>0) hh=(root.h*dsk->top.yperc)>>10;
	else hh=dsk->top.im->rgb_height;
	if (dsk->top.keep_aspect)
	  {
	     if (((ww<<10)/hh)!=
		 ((dsk->top.im->rgb_width<<10)/dsk->top.im->rgb_height))
	       hh=((ww*dsk->top.im->rgb_height)/dsk->top.im->rgb_width);
	  }
	Imlib_render(id,dsk->top.im,ww,hh);
	pmap=Imlib_move_image(id,dsk->top.im);
        mask=Imlib_move_mask(id,dsk->top.im);
	x=((root.w-ww)*dsk->top.xjust)>>10;
	y=((root.h-hh)*dsk->top.yjust)>>10;
	XSetTile(disp,gc,pmap);
	XSetTSOrigin(disp,gc,x,y);
	XSetFillStyle(disp,gc,FillTiled);
	if (mask)
	  {
	     XSetClipMask(disp,gc,mask);
	     XSetClipOrigin(disp,gc,x,y);
	  }
	XFillRectangle(disp,dsk->pmap,gc,x,y,ww,hh);
	Imlib_free_pixmap(id,pmap);
     }
   if (dsk->top.im) Imlib_kill_image(id,dsk->top.im);
   if (dsk->bg.im) Imlib_kill_image(id,dsk->bg.im);
   dsk->top.im=NULL;
   dsk->bg.im=NULL;
   if (dsk->pmap) XSetWindowBackgroundPixmap(disp,root.win,dsk->pmap);
   else XSetWindowBackground(disp,root.win,dsk->bg.solid.pixel);	
   XClearWindow(disp,root.win);
   if (gc) XFreeGC(disp,gc);
}

void InitDesktopBgs()
{
   int i;
   Desk *d;
   
   for (i=0;i<32;i++)
     {
	d=&desks.desk[i];
	d->pmap=0;
	d->bg.solid.r=160;
	d->bg.solid.g=160;
	d->bg.solid.b=160;
	d->bg.file=NULL;
	d->bg.im=NULL;
	d->bg.tile=1;
	d->bg.keep_aspect=1;
	d->bg.xjust=512;
	d->bg.yjust=512;
	d->bg.xperc=1024;
	d->bg.yperc=1024;
	d->top.file=NULL;
	d->top.im=NULL;
	d->top.keep_aspect=1;
	d->top.xjust=512;
	d->top.yjust=512;
	d->top.xperc=0;
	d->top.yperc=0;
     }
}

void SetDesktopBg(int desk, ImlibColor *solid, 
		  char *bg, char tile, char keep_aspect,
		  int xjust, int yjust, int xperc, int yperc, 
		  char *top, char tkeep_aspect,
		  int txjust, int tyjust, int txperc, int typerc)
{
   Desk *d;
   
   d=&desks.desk[desk&0x1f];
   Imlib_free_pixmap(id,d->pmap);
   if (solid)
     {
	d->bg.solid.r=solid->r;
	d->bg.solid.g=solid->g;
	d->bg.solid.b=solid->b;
     }
   if (d->bg.file) Efree(d->top.file);
   d->bg.file=NULL;
   if (bg) d->bg.file=duplicate(bg);
   d->bg.im=NULL;
   d->bg.tile=tile;
   d->bg.keep_aspect=keep_aspect;
   d->bg.xjust=xjust;
   d->bg.yjust=yjust;
   d->bg.xperc=xperc;
   d->bg.yperc=yperc;

   if (d->top.file) Efree(d->top.file);
   d->top.file=NULL;
   if (top) d->top.file=duplicate(top);
   d->top.im=NULL;
   d->top.keep_aspect=tkeep_aspect;
   d->top.xjust=txjust;
   d->top.yjust=tyjust;
   d->top.xperc=txperc;
   d->top.yperc=typerc;
   if (desk==desks.current) RefreshCurrentDesktop();
}

void ConformEwinToDesktop(EWin *ewin)
{
   if (ewin->iconified) return;
   if (desks.current_mask&ewin->desktop) ShowEwin(ewin);
   else HideEwin(ewin);
}

void MoveEwinToDesktop(EWin *ewin, int num)
{
   int num_mask;
   
   num&=0x1f;
   num_mask=1<<(num);
   if (ewin->desktop&num) return;
   ewin->desktop|=num_mask;
   if ((!ewin->sticky)&&(desks.current!=num))
     ewin->desktop&=~desks.current_mask;
   ConformEwinToDesktop(ewin);
}

void RemoveEwinFromDesktop(EWin *ewin, int num)
{
   int num_mask;
   
   num&=0x1f;
   num_mask=1<<(num);
   if (ewin->desktop&num) return;
   ewin->desktop&=~desks.current_mask;
   ConformEwinToDesktop(ewin);
}

void AddEwinFromDesktop(EWin *ewin, int num)
{
   int num_mask;
   
   num&=0x1f;
   num_mask=1<<(num);
   if (ewin->desktop&num) return;
   ewin->desktop|=num_mask;
   ConformEwinToDesktop(ewin);
}
