#include "E.h"

void HandleEvent(XEvent *ev)
{
   void **lst;
   int i,num;
   
/*   printf("Event: %x\n",ev->type);*/
   if (ev->type==event_base_shape+ShapeNotify)
     HandleChildShapeChange(ev);
   lst=ListItemType(&num,LIST_TYPE_ACLASS_GLOBAL);
   if (lst)
     {
	for (i=0;i<num;i++) EventAclass(ev,(ActionClass *)lst[i]);
	Efree(lst);
     }
   switch (ev->type)
     {
      case Expose:
	if (!ev->xexpose.count) HandleExpose(ev);
	break;
      case ButtonPress:
	HandleMouseDown(ev);
	break;
      case ButtonRelease:
	HandleMouseUp(ev);
	break;
      case EnterNotify:
	if (mode.mode==MODE_NONE)
	  {
	     HandleMouseIn(ev);
	     HandleFocusWindow(ev->xcrossing.window);
	  }
	break;
      case LeaveNotify:
	if (mode.mode==MODE_NONE)	
	  HandleMouseOut(ev);
	break;
      case MapRequest:
	HandleMapRequest(ev);
	break;
      case DestroyNotify:
	HandleDestroy(ev);
	break;
      case UnmapNotify:
	HandleUnmap(ev);
	break;
      case ClientMessage:
	  {
	     Atom a;
	     
	     a=XInternAtom(disp,"ENL_MSG",False);
	     if (ev->xclient.message_type==a)
	       HandleComms(ev);
	  }
	break;
      case ConfigureRequest:
	HandleConfigureRequest(ev);
	break;
      case ResizeRequest:
	HandleResizeRequest(ev);
	break;
      case PropertyNotify:
	HandleProperty(ev);
	break;
      case CirculateRequest:
	HandleCirculate(ev);
	break;
      case ReparentNotify:
	HandleReparent(ev);
	break;
      case KeyPress:
	break;
      case KeyRelease:
	break;
      case MotionNotify:
	while (XCheckTypedEvent(disp,ev->type,ev));
	HandleMotion(ev);
	break;
      case FocusIn:
	break;
      case FocusOut:
	break;
      default:
	break;
     }
}

void CheckEvent()
{
   XEvent ev;
   
   while (XCheckMaskEvent(disp,SubstructureNotifyMask|ButtonPressMask|
			  ButtonReleaseMask|EnterWindowMask|LeaveWindowMask|
			  ButtonMotionMask|PropertyChangeMask|
			  SubstructureRedirectMask|KeyPressMask|
			  KeyReleaseMask|PointerMotionMask|ExposureMask
			  ,&ev))
     HandleEvent(&ev);
}

void WaitEvent()
{
   XEvent ev;
   
   XNextEvent(disp,&ev);
   HandleEvent(&ev);
}
