#include "E.h"

void HandleFocusWindow(Window win)
{
   EWin *found_ewin;
   
   found_ewin=FindEwinByChildren(win);
   if (found_ewin!=mode.mouse_over_win) 
     mode.mouse_over_win=found_ewin;
   if (mode.focusmode==FOCUS_CLICK)
     {
	if (!mode.focuswin)
	  GrabTheButtons(root.win);
	else if (mode.click_focus_grabbed)
	  {
	     if (mode.mouse_over_win==mode.focuswin)
	       UnGrabTheButtons();
	  }
	else
	  {
	     if (mode.mouse_over_win!=mode.focuswin)
	       GrabTheButtons(root.win);
	  }
     }
   else if (mode.focusmode==FOCUS_SLOPPY)
     {
	if (found_ewin!=mode.focuswin)
	  {
	     if (found_ewin)
	       FocusToEWin(found_ewin);
	  }
     }
   else if (mode.focusmode==FOCUS_POINTER)
     {
	if (found_ewin!=mode.focuswin)
	  FocusToEWin(found_ewin);
     }
}

void HandleChildShapeChange(XEvent *ev)
{
   Window win;
   EWin *ewin;
   Border *b;
   
   win=((XShapeEvent *)ev)->window;
   ewin=FindItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin) 
     {
	b=ewin->border;
	SyncBorderToEwin(ewin);
	if (ewin->border==b) PropagateShapes(ewin->win);
     }
}

void HandleMotion(XEvent *ev)
{
   int dx,dy;
   int x,y,w,h;
   EWin *ewin;
   
   mode.px=mode.x;mode.py=mode.y;
   mode.x=ev->xmotion.x_root;mode.y=ev->xmotion.y_root;
   ewin=NULL;
   switch (mode.mode)
     {
      case MODE_MOVE:
	if (mode.ewin)
	  {
	     ewin=mode.ewin;
	     dx=mode.x-mode.px;dy=mode.y-mode.py;
	     DrawEwinShape(ewin,mode.movemode,ewin->x+dx,ewin->y+dy,
			   ewin->client.w,ewin->client.h,mode.firstlast);
	  }
	break;
      case MODE_RESIZE:
	if (mode.ewin)
	  {
	     ewin=mode.ewin;
	     switch (mode.resize_detail)
	       {
		case 0:
		  w=mode.win_w-(mode.x-mode.start_x);
		  h=mode.win_h-(mode.y-mode.start_y);
		  x=mode.win_x+(mode.x-mode.start_x);
		  y=mode.win_y+(mode.y-mode.start_y);
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		case 1:
		  w=mode.win_w+(mode.x-mode.start_x);
		  h=mode.win_h-(mode.y-mode.start_y);
		  x=ewin->x;
		  y=mode.win_y+(mode.y-mode.start_y);
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		case 2:
		  w=mode.win_w-(mode.x-mode.start_x);
		  h=mode.win_h+(mode.y-mode.start_y);
		  x=mode.win_x+(mode.x-mode.start_x);
		  y=ewin->y;
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		case 3:
		  w=mode.win_w+(mode.x-mode.start_x);
		  h=mode.win_h+(mode.y-mode.start_y);
		  x=ewin->x;
		  y=ewin->y;
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		default:
		  break;
	       }
	  }
	break;
      case MODE_RESIZE_H:
	if (mode.ewin)
	  {
	     ewin=mode.ewin;
	     switch (mode.resize_detail)
	       {
		case 0:
		  w=mode.win_w-(mode.x-mode.start_x);
		  h=ewin->client.h;
		  x=mode.win_x+(mode.x-mode.start_x);
		  y=ewin->y;
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		case 1:
		  w=mode.win_w+(mode.x-mode.start_x);
		  h=ewin->client.h;
		  x=ewin->x;
		  y=ewin->y;
		  ICCCM_MatchSize(ewin);
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		default:
		  break;
	       }
	  }
	break;
      case MODE_RESIZE_V:
	if (mode.ewin)
	  {
	     ewin=mode.ewin;
	     switch (mode.resize_detail)
	       {
		case 0:
		  w=ewin->client.w;
		  h=mode.win_h-(mode.y-mode.start_y);
		  x=ewin->x;
		  y=mode.win_y+(mode.y-mode.start_y);
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		case 1:
		  w=ewin->client.w;
		  h=mode.win_h+(mode.y-mode.start_y);
		  x=ewin->x;
		  y=ewin->y;
		  DrawEwinShape(ewin,mode.resizemode,x,y,w,h,mode.firstlast);
		  break;
		default:
		  break;
	       }
	  }
	break;
      default:
	break;
     }
}

void HandleDestroy(XEvent *ev)
{
   Window win;
   EWin *ewin;
   Client *c;
   
   win=ev->xunmap.window;
   ewin=RemoveItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin)
     {
	if (ewin==mode.ewin)
	  {
	     switch(mode.mode)
	       {
		case MODE_RESIZE:
		case MODE_RESIZE_H:
		case MODE_RESIZE_V:
		  doResizeEnd(NULL);
		  break;
		case MODE_MOVE:
		  doMoveEnd(NULL);
		  break;
		default:
		  break;
	       }
	  }
	if (ewin==mode.focuswin) FocusToEWin(NULL);
	if (ewin==mode.mouse_over_win) mode.mouse_over_win=NULL;
	if (ewin==mode.ewin) mode.ewin=NULL;
	FreeEwin(ewin);
	return;
     }
   c=FindItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_CLIENT);
   if (c)
     DeleteClient(c);
}

void HandleProperty(XEvent *ev)
{
   Window win;
   EWin *ewin;
   
   win=ev->xproperty.window;
   ewin=FindItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin)
     {
	ICCCM_GetColormap(ewin);
	SyncBorderToEwin(ewin);
     }
}

void HandleCirculate(XEvent *ev)
{
   Window win;
   EWin *ewin;
   
   win=ev->xcirculaterequest.window;
   ewin=FindItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin)
     {
	if (ev->xcirculaterequest.place==PlaceOnTop)
	  XRaiseWindow(disp,ewin->win);
	else
	  XLowerWindow(disp,ewin->win);
     }
   else
     {
	if (ev->xcirculaterequest.place==PlaceOnTop)
	  XRaiseWindow(disp,win);
	else
	  XLowerWindow(disp,win);
     }
}

void HandleReparent(XEvent *ev)
{
   Window par;
   EWin *ewin,*ewin2;
   void **lst;
   int i,num,found=0;
   
   par=ev->xreparent.window;
   printf("event %x reparent %x to %x\n",
	  (unsigned int)ev->xreparent.event,
	  (unsigned int)ev->xreparent.window,
	  (unsigned int)ev->xreparent.parent);
   return;
   ewin=FindItem(NULL,ev->xreparent.window,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (!ewin) return;
   lst=ListItemType(&num,LIST_TYPE_EWIN);
   if ((lst)&&(num>0))
     {
	for(i=0;i<num;i++)
	  {
	     ewin2=(EWin *)lst[i];
	     if (ewin2->win==ev->xreparent.parent) found=1;
	  }
	Efree(lst);
     }
   if (!found)
     {
	ewin=RemoveItem(NULL,ev->xreparent.window,LIST_FINDBY_ID,LIST_TYPE_EWIN);
	if (ewin)
	  {
	     if (ewin==mode.ewin)
	       {
		  switch(mode.mode)
		    {
		     case MODE_RESIZE:
		     case MODE_RESIZE_H:
		     case MODE_RESIZE_V:
		       doResizeEnd(NULL);
		       break;
		     case MODE_MOVE:
		       doMoveEnd(NULL);
		       break;
		     default:
		       break;
		    }
	       }
	     ewin->client.win=0;
	     FreeEwin(ewin);
	  }
     }
   return;
}

void HandleConfigureRequest(XEvent *ev)
{
   Window win;
   EWin *ewin;
   int x=0,y=0,w=0,h=0;
   int move=0,resize=0;
   XWindowChanges xwc;
   
   win=ev->xconfigurerequest.window;
   ewin=FindItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin)
     {
	if (ev->xconfigurerequest.value_mask&CWX)
	  {
	     x=ev->xconfigurerequest.x;
	     move=1;
	  }
	if (ev->xconfigurerequest.value_mask&CWY)
	  {
	     y=ev->xconfigurerequest.y;
	     move=1;
	  }
	if (ev->xconfigurerequest.value_mask&CWWidth)
	  {
	     w=ev->xconfigurerequest.width;
	     resize=1;
	  }
	if (ev->xconfigurerequest.value_mask&CWHeight)
	  {
	     h=ev->xconfigurerequest.height;
	     resize=1;
	  }
	if ((move)&&(resize))
	  MoveResizeEwin(ewin,x,y,w,h);
	else if (move)
	  {
	     MoveEwin(ewin,x,y);
	     ICCCM_Configure(ewin);
	  }
	else if (resize)
	  ResizeEwin(ewin,w,h);
     }
   else
     {
	xwc.x=ev->xconfigurerequest.x;
	xwc.y=ev->xconfigurerequest.y;
	xwc.width=ev->xconfigurerequest.width;
	xwc.height=ev->xconfigurerequest.height;
	xwc.border_width=ev->xconfigurerequest.border_width;
	xwc.sibling=ev->xconfigurerequest.above;
	xwc.stack_mode=ev->xconfigurerequest.detail;
	XConfigureWindow(disp,win,ev->xconfigurerequest.value_mask,&xwc);
     }
}

void HandleResizeRequest(XEvent *ev)
{
   Window win;
   EWin *ewin;
   int w,h;
   
   win=ev->xresizerequest.window;
   ewin=FindItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin)
     {
	w=ev->xresizerequest.width;
	h=ev->xresizerequest.height;
	ResizeEwin(ewin,w,h);
     }
   else
     XResizeWindow(disp,win,ev->xresizerequest.width,ev->xresizerequest.height);
}

void HandleUnmap(XEvent *ev)
{
   Window win;
   EWin *ewin;
   
   win=ev->xunmap.window;
   ewin=RemoveItem(NULL,win,LIST_FINDBY_ID,LIST_TYPE_EWIN);
   if (ewin)
     {
	if (ewin==mode.ewin)
	  {
	     switch(mode.mode)
	       {
		case MODE_RESIZE:
		case MODE_RESIZE_H:
		case MODE_RESIZE_V:
		  doResizeEnd(NULL);
		  break;
		case MODE_MOVE:
		  doMoveEnd(NULL);
		  break;
		default:
		  break;
	       }
	  }
	if (ewin==mode.focuswin) FocusToEWin(NULL);
	if (ewin==mode.mouse_over_win) mode.mouse_over_win=NULL;
	if (ewin==mode.ewin) mode.ewin=NULL;
	XRemoveFromSaveSet(disp,ewin->client.win);
	XReparentWindow(disp,ewin->client.win,root.win,
			ewin->client.x,ewin->client.y);
	FreeEwin(ewin);
     }
}

void HandleMapRequest(XEvent *ev)
{
   AddToFamily(ev->xmap.window);
}

void HandleExpose(XEvent *ev)
{
   Window win;
   EWin *ewin;
   int i;
   List *ptr;

   if (ev->xexpose.count>0) return;
   win=ev->xexpose.window;
   ptr=lists.next;
   
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     for(i=0;i<ewin->border->num_winparts;i++)
	       if (win==ewin->bits[i].win)
	       {
		  ewin->bits[i].expose=1;
		  DrawEwinWinpart(ewin,i);
		  return;
	       }
	  }
	ptr=ptr->next;
     }
}

void HandleMouseDown(XEvent *ev)
{
   Window win;
   EWin *ewin;
   int i;
   List *ptr;
   
   win=ev->xbutton.window;
   ptr=lists.next;
   
   if ((mode.focusmode==FOCUS_CLICK)&&(mode.click_focus_grabbed))
     {
	Window rt,ch;
	int dum;
	
	XQueryPointer(disp,root.win,&rt,&ch,&dum,&dum,&dum,&dum,&dum);
	ewin=FindEwinByBase(ch);
	if (ewin) UnGrabTheButtons();
	FocusToEWin(ewin);
	if (ch) XTestFakeButtonEvent(disp,ev->xbutton.button,True,CurrentTime);
     }
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     for(i=0;i<ewin->border->num_winparts;i++)
	       if (win==ewin->bits[i].win)
	       {
		  mode.ewin=ewin;
		  ewin->bits[i].state=STATE_CLICKED;
		  ChangeEwinWinpart(ewin,i);
		  if (ewin->border->part[i].aclass)
		    EventAclass(ev,ewin->border->part[i].aclass);
		  return;
	       }
	  }
	ptr=ptr->next;
     }
}

void HandleMouseUp(XEvent *ev)
{
   Window win;
   EWin *ewin;
   int i;
   List *ptr;
   
   win=ev->xbutton.window;
   ptr=lists.next;
   
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     for(i=0;i<ewin->border->num_winparts;i++)
	       if (win==ewin->bits[i].win)
	       {
		  if (ewin==mode.ewin)
		    {
		       switch(mode.mode)
			 {
			  case MODE_RESIZE:
			  case MODE_RESIZE_H:
			  case MODE_RESIZE_V:
			    doResizeEnd(NULL);
			    break;
			  case MODE_MOVE:
			    doMoveEnd(NULL);
			    break;
			  default:
			    break;
			 }
		    }
		  if (ewin->bits[i].state==STATE_CLICKED)
		    ewin->bits[i].state=STATE_HILITED;
		  else
		    ewin->bits[i].state=STATE_NORMAL;
		  ChangeEwinWinpart(ewin,i);
		  if (ewin->border->part[i].aclass)
		    EventAclass(ev,ewin->border->part[i].aclass);
		  return;
	       }
	  }
	ptr=ptr->next;
     }
}

void HandleMouseIn(XEvent *ev)
{
   Window win;
   EWin *ewin;
   int i;
   List *ptr;
   
   win=ev->xbutton.window;
   ptr=lists.next;
   
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     for(i=0;i<ewin->border->num_winparts;i++)
	       if (win==ewin->bits[i].win)
	       {
		  mode.noewin=0;
		  mode.ewin=ewin;
		  ewin->bits[i].state=STATE_HILITED;
		  ChangeEwinWinpart(ewin,i);
		  if (ewin->border->part[i].aclass)
		    EventAclass(ev,ewin->border->part[i].aclass);
		  return;
	       }
	  }
	ptr=ptr->next;
     }
}

void HandleMouseOut(XEvent *ev)
{
   Window win;
   EWin *ewin;
   int i;
   List *ptr;
   
   win=ev->xbutton.window;
   ptr=lists.next;
   
   while(ptr)
     {
	if (ptr->type==LIST_TYPE_EWIN)
	  {
	     ewin=(EWin *)ptr->item;
	     for(i=0;i<ewin->border->num_winparts;i++)
	       if (win==ewin->bits[i].win)
	       {
		  if (mode.mode==MODE_NONE) mode.ewin=NULL;
		  else mode.noewin=1;
		  ewin->bits[i].state=STATE_NORMAL;
		  ChangeEwinWinpart(ewin,i);
		  if (ewin->border->part[i].aclass)
		    EventAclass(ev,ewin->border->part[i].aclass);
		  return;
	       }
	  }
	ptr=ptr->next;
     }
}
