#include "E.h"

ImageClass *CreateIclass()
{
   ImageClass *i;
   
   i=Emalloc(sizeof(ImageClass));
   if (!i) return NULL;
   i->name=NULL;
   i->external=0;
   i->norm.normal=i->norm.hilited=i->norm.clicked=i->norm.disabled=NULL;
   i->active.normal=i->active.hilited=i->active.clicked=i->active.disabled=NULL;
   i->sticky.normal=i->sticky.hilited=i->sticky.clicked=i->sticky.disabled=NULL;
   i->sticky_active.normal=i->sticky_active.hilited=i->sticky_active.clicked=i->sticky_active.disabled=NULL;
   i->padding.left=0;i->padding.right=0;i->padding.top=0;i->padding.bottom=0;
   return i;
}

ImageState *CreateImageState()
{
   ImageState *is;
   
   is=Emalloc(sizeof(ImageState));
   if (!is) return NULL;
   is->im_file=NULL;
   is->unloadable=0;
   is->im=NULL;
   is->transp=NULL;
   is->border=NULL;
   is->pixmapfillstyle=FILL_STRETCH;
   is->bg.r=160;is->bg.g=160;is->bg.b=160;
   is->hi.r=200;is->hi.g=200;is->hi.b=200;
   is->lo.r=120;is->lo.g=120;is->lo.b=120;
   is->hihi.r=255;is->hihi.g=255;is->hihi.b=255;
   is->lolo.r=64; is->lolo.g=64; is->lolo.b=64;
   is->bevelstyle=BEVEL_NONE;
   return is;
}

void ImageStatePopulate(ImageState *is)
{
   int r,g,b;
   
   if (!is) return;
   r=is->bg.r;g=is->bg.g;b=is->bg.b;
   is->bg.pixel=Imlib_best_color_match(id,&r,&g,&b);
   r=is->hi.r;g=is->hi.g;b=is->hi.b;
   is->hi.pixel=Imlib_best_color_match(id,&r,&g,&b);
   r=is->lo.r;g=is->lo.g;b=is->lo.b;
   is->lo.pixel=Imlib_best_color_match(id,&r,&g,&b);
   r=is->hihi.r;g=is->hihi.g;b=is->hihi.b;
   is->hihi.pixel=Imlib_best_color_match(id,&r,&g,&b);
   r=is->lolo.r;g=is->lolo.g;b=is->lolo.b;
   is->lolo.pixel=Imlib_best_color_match(id,&r,&g,&b);
}

void IclassPopulate(ImageClass *iclass)
{
   if ((!iclass)||(iclass->external)) return;
  
   if (!iclass->norm.normal) return;
   ImageStatePopulate(iclass->norm.normal);
   if (!iclass->norm.hilited) iclass->norm.hilited=iclass->norm.normal;
   else ImageStatePopulate(iclass->norm.hilited);
   if (!iclass->norm.clicked) iclass->norm.clicked=iclass->norm.normal;
   else ImageStatePopulate(iclass->norm.clicked);
   if (!iclass->norm.disabled) iclass->norm.disabled=iclass->norm.normal;
   else ImageStatePopulate(iclass->norm.disabled);

   if (!iclass->active.normal) iclass->active.normal=iclass->norm.normal;
   else ImageStatePopulate(iclass->active.normal);
   if (!iclass->active.hilited) iclass->active.hilited=iclass->active.normal;
   else ImageStatePopulate(iclass->active.hilited);
   if (!iclass->active.clicked) iclass->active.clicked=iclass->active.normal;
   else ImageStatePopulate(iclass->active.clicked);
   if (!iclass->active.disabled) iclass->active.disabled=iclass->active.normal;
   else ImageStatePopulate(iclass->active.disabled);

   if (!iclass->sticky.normal) iclass->sticky.normal=iclass->norm.normal;
   else ImageStatePopulate(iclass->sticky.normal);
   if (!iclass->sticky.hilited) iclass->sticky.hilited=iclass->sticky.normal;
   else ImageStatePopulate(iclass->sticky.hilited);
   if (!iclass->sticky.clicked) iclass->sticky.clicked=iclass->sticky.normal;
   else ImageStatePopulate(iclass->sticky.clicked);
   if (!iclass->sticky.disabled) iclass->sticky.disabled=iclass->sticky.normal;
   else ImageStatePopulate(iclass->sticky.disabled);

   if (!iclass->sticky_active.normal) iclass->sticky_active.normal=iclass->norm.normal;
   else ImageStatePopulate(iclass->sticky_active.normal);
   if (!iclass->sticky_active.hilited) iclass->sticky_active.hilited=iclass->sticky_active.normal;
   else ImageStatePopulate(iclass->sticky_active.hilited);
   if (!iclass->sticky_active.clicked) iclass->sticky_active.clicked=iclass->sticky_active.normal;
   else ImageStatePopulate(iclass->sticky_active.clicked);
   if (!iclass->sticky_active.disabled) iclass->sticky_active.disabled=iclass->sticky_active.normal;
   else ImageStatePopulate(iclass->sticky_active.disabled);
}

void IclassApply(ImageClass *iclass, Window win, int w, int h, int active, int state, char expose)
{
   ImageState *is;

   if ((!iclass)||(!win)||(w<1)||(h<1)) return;
   if (iclass->external) return;
   is=NULL;
   
   printf("ICLASS apply to %x %ix%i active %i state %i expose %i\n",win,w,h,active,state,expose);
   switch (active&(EWIN_ACTIVE|EWIN_STICKY))
     {
      case EWIN_ACTIVE:
	switch(state)
	  {
	   case STATE_NORMAL:
	     is=iclass->active.normal;
	     break;
	   case STATE_HILITED:
	     is=iclass->active.hilited;
	     break;
	   case STATE_CLICKED:
	     is=iclass->active.clicked;
	     break;
	   case STATE_DISABLED:
	     is=iclass->active.disabled;
	     break;
	   default:
	     break;
	  }
	break;
      case EWIN_STICKY:
	switch(state)
	  {
	   case STATE_NORMAL:
	     is=iclass->sticky.normal;
	     break;
	   case STATE_HILITED:
	     is=iclass->sticky.hilited;
	     break;
	   case STATE_CLICKED:
	     is=iclass->sticky.clicked;
	     break;
	   case STATE_DISABLED:
	     is=iclass->sticky.disabled;
	     break;
	   default:
	     break;
	  }
	break;
      case (EWIN_ACTIVE|EWIN_STICKY):
	switch(state)
	  {
	   case STATE_NORMAL:
	     is=iclass->sticky_active.normal;
	     break;
	   case STATE_HILITED:
	     is=iclass->sticky_active.hilited;
	     break;
	   case STATE_CLICKED:
	     is=iclass->sticky_active.clicked;
	     break;
	   case STATE_DISABLED:
	     is=iclass->sticky_active.disabled;
	     break;
	   default:
	     break;
	  }
	break;
      case 0:
	switch(state)
	  {
	   case STATE_NORMAL:
	     is=iclass->norm.normal;
	     break;
	   case STATE_HILITED:
	     is=iclass->norm.hilited;
	     break;
	   case STATE_CLICKED:
	     is=iclass->norm.clicked;
	     break;
	   case STATE_DISABLED:
	     is=iclass->norm.disabled;
	     break;
	   default:
	     break;
	  }
	break;
      default:
	break;
     }
   if (is)
     {
	XGCValues gcv;
	GC gc;
	Pixmap pmap,mask;
	
	if (!expose)
	  {
	     if (is->im_file)
	       {
		  /* has bg pixmap */
		  if (!is->im) 
		    {
		       /* not loaded, load and setup */
		       is->im=ELoadImage(is->im_file);
		       if (is->border)
			 Imlib_set_image_border(id,is->im,is->border);
		       if (is->transp)
			 Imlib_set_image_shape(id,is->im,is->transp);
		    }
		  if (is->im)
		    {
		       /* if image, render */
		       switch (is->pixmapfillstyle)
			 {
			  case FILL_STRETCH:
			  case FILL_TILE:
			  case FILL_INTEGER_TILE:
			    Imlib_render(id,is->im,w,h);
			    pmap=Imlib_move_image(id,is->im);
			    mask=Imlib_move_mask(id,is->im);
			    if (pmap) XSetWindowBackgroundPixmap(disp,win,pmap);
			    if (mask) XShapeCombineMask(disp,win,ShapeBounding,
							0,0,mask,ShapeSet);
			    Imlib_free_pixmap(id,pmap);
			    break;
			  default:
			    break;
			 }
		    }
	       }
	     if (!is->im)
	       {
		  /* bg color */
		  XSetWindowBackground(disp,win,is->bg.pixel);
	       }
	     else if (is->im_file)
	       {
		  /* if unloadable - then unload */
		  if (is->unloadable) 
		    {
		       Imlib_destroy_image(id,is->im);
		       is->im=NULL;
		    }
	       }
	  }
	XClearWindow(disp,win);
	/* if there is a bevel to draw, draw it */     
	if (is->bevelstyle!=BEVEL_NONE)
	  {
	     gc=XCreateGC(disp,win,0,&gcv);
	     switch (is->bevelstyle)
	       {
		case BEVEL_AMIGA:
		  XSetForeground(disp,gc,is->hihi.pixel);
		  XDrawLine(disp,win,gc,0,0,w-2,0);
		  XDrawLine(disp,win,gc,0,0,0,h-2);
		  XSetForeground(disp,gc,is->lolo.pixel);
		  XDrawLine(disp,win,gc,1,h-1,w-1,h-1);
		  XDrawLine(disp,win,gc,w-1,1,w-1,h-1);
		  break;
		case BEVEL_MOTIF:
		  XSetForeground(disp,gc,is->hi.pixel);
		  XDrawLine(disp,win,gc,0,0,w-1,0);
		  XDrawLine(disp,win,gc,0,0,0,h-1);
		  XDrawLine(disp,win,gc,1,1,w-2,1);
		  XDrawLine(disp,win,gc,1,1,1,h-2);
		  XSetForeground(disp,gc,is->lo.pixel);
		  XDrawLine(disp,win,gc,0,h-1,w-1,h-1);
		  XDrawLine(disp,win,gc,w-1,1,w-1,h-1);
		  XDrawLine(disp,win,gc,1,h-2,w-2,h-2);
		  XDrawLine(disp,win,gc,w-2,2,w-2,h-2);
		  break;
		case BEVEL_NEXT:
		  XSetForeground(disp,gc,is->hihi.pixel);
		  XDrawLine(disp,win,gc,0,0,w-1,0);
		  XDrawLine(disp,win,gc,0,0,0,h-1);
		  XSetForeground(disp,gc,is->hi.pixel);
		  XDrawLine(disp,win,gc,1,1,w-2,1);
		  XDrawLine(disp,win,gc,1,1,1,h-2);
		  XSetForeground(disp,gc,is->lolo.pixel);
		  XDrawLine(disp,win,gc,1,h-1,w-1,h-1);
		  XDrawLine(disp,win,gc,w-1,1,w-1,h-1);
		  XSetForeground(disp,gc,is->lo.pixel);
		  XDrawLine(disp,win,gc,2,h-2,w-2,h-2);
		  XDrawLine(disp,win,gc,w-2,2,w-2,h-2);
		  break;
		case BEVEL_DOUBLE:
		  XSetForeground(disp,gc,is->hi.pixel);
		  XDrawLine(disp,win,gc,0,0,w-2,0);
		  XDrawLine(disp,win,gc,0,0,0,h-2);
		  XSetForeground(disp,gc,is->lo.pixel);
		  XDrawLine(disp,win,gc,1,1,w-3,1);
		  XDrawLine(disp,win,gc,1,1,1,h-3);
		  XSetForeground(disp,gc,is->lo.pixel);
		  XDrawLine(disp,win,gc,1,h-1,w-1,h-1);
		  XDrawLine(disp,win,gc,w-1,1,w-1,h-1);
		  XSetForeground(disp,gc,is->hi.pixel);
		  XDrawLine(disp,win,gc,2,h-2,w-2,h-2);
		  XDrawLine(disp,win,gc,w-2,2,w-2,h-2);
		  break;
		case BEVEL_WIDEDOUBLE:
		  XSetForeground(disp,gc,is->hihi.pixel);
		  XDrawLine(disp,win,gc,0,0,w-1,0);
		  XDrawLine(disp,win,gc,0,0,0,h-1);
		  XSetForeground(disp,gc,is->hi.pixel);
		  XDrawLine(disp,win,gc,1,1,w-2,1);
		  XDrawLine(disp,win,gc,1,1,1,h-2);
		  XDrawLine(disp,win,gc,3,h-4,w-4,h-4);
		  XDrawLine(disp,win,gc,w-4,3,w-4,h-4);
		  XSetForeground(disp,gc,is->lolo.pixel);
		  XDrawLine(disp,win,gc,1,h-1,w-1,h-1);
		  XDrawLine(disp,win,gc,w-1,1,w-1,h-1);
		  XSetForeground(disp,gc,is->lo.pixel);
		  XDrawLine(disp,win,gc,2,h-2,w-2,h-2);
		  XDrawLine(disp,win,gc,w-2,2,w-2,h-2);
		  XDrawLine(disp,win,gc,3,3,w-4,3);
		  XDrawLine(disp,win,gc,3,3,3,h-4);
		  break;
		case BEVEL_THINPOINT:
		  XSetForeground(disp,gc,is->hi.pixel);
		  XDrawLine(disp,win,gc,0,0,w-2,0);
		  XDrawLine(disp,win,gc,0,0,0,h-2);
		  XSetForeground(disp,gc,is->lo.pixel);
		  XDrawLine(disp,win,gc,1,h-1,w-1,h-1);
		  XDrawLine(disp,win,gc,w-1,1,w-1,h-1);
		  XSetForeground(disp,gc,is->hihi.pixel);
		  XDrawLine(disp,win,gc,0,0,1,0);
		  XDrawLine(disp,win,gc,0,0,0,1);
		  XSetForeground(disp,gc,is->lolo.pixel);
		  XDrawLine(disp,win,gc,w-2,h-1,w-1,h-1);
		  XDrawLine(disp,win,gc,w-1,h-2,w-1,h-1);
		  XSync(disp,False);
		  break;
		case BEVEL_THICKPOINT:
		  XSetForeground(disp,gc,is->hi.pixel);
		  XDrawRectangle(disp,win,gc,0,0,w-1,h-1);
		  break;
		default:
		  break;
	       }
	     XFreeGC(disp,gc);
	  }
     }
}
