#include "E.h"

void *FindItem(char *name, int id, int find_by, int type)
{
   List *ptr;
   
   ptr=lists.next;
   if (find_by==LIST_FINDBY_NAME)
     {
	while(ptr)
	  {
	     if ((ptr->type==type)&&(!strcmp(name,ptr->name)))
	       return ptr->item;
	     ptr=ptr->next;
	  }
     }
   else if (find_by==LIST_FINDBY_ID)
     {
	while(ptr)
	  {
	     if ((ptr->type==type)&&(ptr->id==id))
	       return ptr->item;
	     ptr=ptr->next;
	  }
     }
   else if (find_by==LIST_FINDBY_BOTH)
     {
	while(ptr)
	  {
	     if ((ptr->type==type)&&(!strcmp(name,ptr->name))&&(ptr->id==id))
	       return ptr->item;
	     ptr=ptr->next;
	  }
     }
   return NULL;
}

void AddItem(void *item, char *name, int id, int type)
{
   List *ptr;
   
   ptr=Emalloc(sizeof(List));
   if (!ptr) return;
   ptr->item=item;
   ptr->name=duplicate(name);
   ptr->id=id;
   ptr->type=type;
   ptr->next=lists.next;
   lists.next=ptr;
}

void *RemoveItem(char *name, int id, int find_by, int type)
{
   List *ptr,*pptr;
   void *p;
   
   pptr=NULL;
   ptr=lists.next;
   if (find_by==LIST_FINDBY_NAME)
     {
	while(ptr)
	  {
	     if ((ptr->type==type)&&(!strcmp(name,ptr->name)))
	       {
		  if (pptr)
		    pptr->next=ptr->next;
		  else
		    lists.next=ptr->next;
		  p=ptr->item;
		  if (ptr->name) Efree(ptr->name);
		  Efree(ptr);
		  return p;
	       }
	     pptr=ptr;
	     ptr=ptr->next;
	  }
     }
   else if (find_by==LIST_FINDBY_ID)
     {
	while(ptr)
	  {
	     if ((ptr->type==type)&&(ptr->id==id))
	       {
		  if (pptr)
		    pptr->next=ptr->next;
		  else
		    lists.next=ptr->next;
		  p=ptr->item;
		  if (ptr->name) Efree(ptr->name);
		  Efree(ptr);
		  return p;
	       }
	     pptr=ptr;
	     ptr=ptr->next;
	  }
     }
   else if (find_by==LIST_FINDBY_BOTH)
     {
	while(ptr)
	  {
	     if ((ptr->type==type)&&(!strcmp(name,ptr->name))&&(ptr->id==id))
	       {
		  if (pptr)
		    pptr->next=ptr->next;
		  else
		    lists.next=ptr->next;
		  p=ptr->item;
		  if (ptr->name) Efree(ptr->name);
		  Efree(ptr);
		  return p;
	       }
	     pptr=ptr;
	     ptr=ptr->next;
	  }
     }
   return NULL;
}

void **ListItemType(int *num, int type)
{
   List *ptr;
   int i,len;
   void **lst;
   
   *num=0;
   len=0;
   if (type==LIST_TYPE_ANY) return NULL;
   ptr=lists.next;
   while(ptr)
     {
	if (ptr->type==type) len++;
	ptr=ptr->next;
     }
   if (!len) return NULL;
   lst=Emalloc(len*sizeof(void *));
   i=0;
   ptr=lists.next;
   while(ptr)
     {
	if (ptr->type==type) lst[i++]=ptr->item;
	ptr=ptr->next;
     }
   *num=i;
   return lst;
}

char **ListItems(int *num, int type)
{
   List *ptr;
   int i,len;
   char **list;
   
   i=0;len=0;
   list=NULL;
   ptr=lists.next;
   if (type!=LIST_TYPE_ANY) 
     {
	while(ptr) 
	  {
	     if (ptr->type==type) len++;
	     ptr=ptr->next;
	  }
     }
   else
     {     
	while(ptr) 
	  {
	     len++;
	     ptr=ptr->next;
	  }
     }
   list=Emalloc(len*sizeof(char *));
   if (!list) 
     {
	*num=0;
	return NULL;
     }
   ptr=lists.next;
   if (type!=LIST_TYPE_ANY) 
     {
	while(ptr) 
	  {
	     if (ptr->type==type)
	       {
		  list[i]=duplicate(ptr->name);
		  i++;
	       }
	     ptr=ptr->next;
	  }
     }
   else
     {
	while(ptr) 
	  {
	     list[i]=duplicate(ptr->name);
	     i++;
	     ptr=ptr->next;
	  }
     }
   *num=len;
   return list;
}

